# wxAnimationCtrl Class Reference
[Controls]

`#include <wx/animate.h>`

Inheritance diagram for wxAnimationCtrl:
[legend]

## Detailed Description

This is a static control which displays an animation.

wxAnimationCtrl API is as simple as possible and won't give you full control on the animation; if you need it then use wxMediaCtrl.

This control is useful to display a (small) animation while doing a long task (e.g. a "throbber").

It is only available if `wxUSE_ANIMATIONCTRL` is set to 1 (the default).

## Styles

This class supports the following styles:

- wxAC_DEFAULT_STYLE:
  The default style: wxBORDER_NONE.
- wxAC_NO_AUTORESIZE:
  By default, the control will adjust its size to exactly fit to the size of the animation when SetAnimation is called. If this style flag is given, the control will not change its size

##

Library: wxAdvanced

Category: Controls

Implementations: native under wxGTK, wxMSW ports; a generic implementation is used elsewhere.

Appearance:

wxMSW appearance | wxGTK appearance | wxMac appearance

See also:
  wxAnimation, Animation Sample

## Public Member Functions
| wxAnimationCtrl (wxWindow *parent, wxWindowID id, const wxAnimation &anim=wxNullAnimation, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxAC_DEFAULT_STYLE, const wxString &name=wxAnimationCtrlNameStr)
| Initializes the object and calls Create() with all the parameters.
bool | Create (wxWindow *parent, wxWindowID id, const wxAnimation &anim=wxNullAnimation, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxAC_DEFAULT_STYLE, const wxString &name=wxAnimationCtrlNameStr)
| Creates the control with the given anim animation.
virtual wxAnimation | GetAnimation () const
| Returns the animation associated with this control.
wxBitmap | GetInactiveBitmap () const
| Returns the inactive bitmap shown in this control when the; see SetInactiveBitmap() for more info.
virtual bool | IsPlaying () const
| Returns true if the animation is being played.
virtual bool | LoadFile (const wxString &file, wxAnimationType animType=wxANIMATION_TYPE_ANY)
| Loads the animation from the given file and calls SetAnimation().
virtual bool | Load (wxInputStream &file, wxAnimationType animType=wxANIMATION_TYPE_ANY)
| Loads the animation from the given stream and calls SetAnimation().
virtual bool | Play ()
| Starts playing the animation.
virtual void | SetAnimation (const wxAnimation &anim)
| Sets the animation to play in this control.
virtual void | SetInactiveBitmap (const wxBitmap &bmp)
| Sets the bitmap to show on the control when it's not playing an animation.
virtual void | Stop ()
| Stops playing the animation.

List of all members.

## Constructor & Destructor Documentation

wxAnimationCtrl::wxAnimationCtrl | ( | wxWindow * | parent,
|  | wxWindowID | id,
|  | const wxAnimation & | anim = `wxNullAnimation`,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `wxAC_DEFAULT_STYLE`,
|  | const wxString & | name = `wxAnimationCtrlNameStr` |
| ) |  |  |

Initializes the object and calls Create() with all the parameters.

## Member Function Documentation

bool wxAnimationCtrl::Create | ( | wxWindow * | parent,
|  | wxWindowID | id,
|  | const wxAnimation & | anim = `wxNullAnimation`,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `wxAC_DEFAULT_STYLE`,
|  | const wxString & | name = `wxAnimationCtrlNameStr` |
| ) |  |  |

Creates the control with the given anim animation.

After control creation you must explicitly call Play() to start to play the animation. Until that function won't be called, the first frame of the animation is displayed.

Parameters:

  | parent | Parent window, must be non-NULL.
  | id | The identifier for the control.
  | anim | The initial animation shown in the control.
  | pos | Initial position.
  | size | Initial size.
  | style | The window style, see wxAC_* flags.
  | name | Control name.

Returns:
  true if the control was successfully created or false if creation failed.

virtual wxAnimation wxAnimationCtrl::GetAnimation | ( |  | ) | const`[virtual]`

Returns the animation associated with this control.

wxBitmap wxAnimationCtrl::GetInactiveBitmap | ( |  | ) | const

Returns the inactive bitmap shown in this control when the; see SetInactiveBitmap() for more info.

virtual bool wxAnimationCtrl::IsPlaying | ( |  | ) | const`[virtual]`

Returns true if the animation is being played.

virtual bool wxAnimationCtrl::Load | ( | wxInputStream & | file,
|  | wxAnimationType | animType = `wxANIMATION_TYPE_ANY` |
| ) |  |  | `[virtual]`

Loads the animation from the given stream and calls SetAnimation().

See wxAnimation::Load() for more info.

virtual bool wxAnimationCtrl::LoadFile | ( | const wxString & | file,
|  | wxAnimationType | animType = `wxANIMATION_TYPE_ANY` |
| ) |  |  | `[virtual]`

Loads the animation from the given file and calls SetAnimation().

See wxAnimation::LoadFile for more info.

virtual bool wxAnimationCtrl::Play | ( |  | ) | `[virtual]`

Starts playing the animation.

The animation is always played in loop mode (unless the last frame of the animation has an infinite delay time) and always start from the first frame even if you stopped it while some other frame was displayed.

virtual void wxAnimationCtrl::SetAnimation | ( | const wxAnimation & | anim | ) | `[virtual]`

Sets the animation to play in this control.

If the previous animation is being played, it's Stop() stopped. Until Play() isn't called, a static image, the first frame of the given animation or the background colour will be shown (see SetInactiveBitmap() for more info).

virtual void wxAnimationCtrl::SetInactiveBitmap | ( | const wxBitmap & | bmp | ) | `[virtual]`

Sets the bitmap to show on the control when it's not playing an animation.

If you set as inactive bitmap wxNullBitmap (which is the default), then the first frame of the animation is instead shown when the control is inactive; in this case, if there's no valid animation associated with the control (see SetAnimation()), then the background colour of the window is shown.

If the control is not playing the animation, the given bitmap will be immediately shown, otherwise it will be shown as soon as Stop() is called.

Note that the inactive bitmap, if smaller than the control's size, will be centered in the control; if bigger, it will be stretched to fit it.

virtual void wxAnimationCtrl::Stop | ( |  | ) | `[virtual]`

Stops playing the animation.

The control will show the first frame of the animation, a custom static image or the window's background colour as specified by the last SetInactiveBitmap() call.

|  | [ top ]